%define basever 1.23
%define subver 11
%global __requires_exclude pear\\((extensions/.*|core/includes/WebStart.php|phase3/includes/WebStart.php|PHPUnit/Framework.php)\\)|/usr/bin/hhvm

Name:		mediawiki
Version:	%{basever}.%{subver}
Release:	%mkrel 1
Summary:	A wiki engine
License:	GPLv2+
Group:		System/Servers
BuildArch:	noarch
Url:		http://www.mediawiki.org/wiki/MediaWiki

Source0:	http://releases.wikimedia.org/mediawiki/%{basever}/%{name}-%{version}.tar.gz
Source1:	mediawiki.conf
# Save sqlite db in mediawiki data dir
Patch0:		mediawiki-1.23.5-sqlite-db-dir-fix.patch
# remove Wikimedia-specific code that causes autoreq deps problems
Patch1:		mediawiki-1.23-no-wikimedia.patch

# to make sure the "apache" group is created before mediawiki is installed
Requires(pre):	webserver-base
Requires:	webserver-base
# suggest apache-mod_php
Recommends:	apache-mod_php
# for diff3:
Requires:	diffutils
# for convert:
Requires:	imagemagick
Requires(post):	php-cli
Requires:	php-gd
Requires:	%{name}-sql = %{version}-%{release}
Requires:	php-xml
Recommends:	php-intl

Conflicts:	mediawiki < 0:1.16.5-0
# make upgrading from mediawiki < 1.19 painless
Obsoletes:	%{name}-minimal < 1.19.1

# RenameUser extension bundled with MediaWiki as of 1.20
Obsoletes:	mediawiki-renameuser < %{version}-%{release}
# GraphViz extension unmaintained and vulnerable to XSS attacks
Obsoletes:	mediawiki-graphviz < 0.9-2

%description
MediaWiki is the software used for Wikipedia and the other Wikimedia
Foundation websites. Compared to other wikis, it has an excellent
range of features and support for high-traffic websites using multiple
servers

This package includes math rendering support for mediawiki.

%package	mysql
Summary:	Mediawiki with mysql database
Group:		System/Servers
Provides:	%{name}-sql = %{version}-%{release}
Requires:	php-mysql

%description	mysql
This meta package installs the neccessary packages to use mediawiki
with a mariadb or mysql database.
This does not install the database server itself, because you can run
mediawiki with a remote database server.

%package	pgsql
Summary:	Mediawiki with postgresql database
Group:		System/Servers
Provides:	%{name}-sql = %{version}-%{release}
Requires:	php-pgsql

%description	pgsql
This meta package installs the neccessary packages to use mediawiki
with a postgresql database.
This does not install the database server itself, because you can run
mediawiki with a remote database server.

%package	sqlite
Summary:	Mediawiki with sqlite database
Group:		System/Servers
Provides:	%{name}-sql = %{version}-%{release}
Requires:	php-sqlite3
Requires:	php-pdo_sqlite

%description	sqlite
This meta package installs the neccessary packages to use mediawiki
with an sqlite database.
If you are using sqlite you can't use a remote database server.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%build
:

%install
# now copy the rest to the buildroot.
mkdir -p %{buildroot}%{_datadir}/mediawiki
cp -a * %{buildroot}%{_datadir}/mediawiki/

# remove documentation
rm -f %{buildroot}%{_datadir}/mediawiki/{COPYING,FAQ,HISTORY,README,README.mediawiki,RELEASE-NOTES-%{basever},UPGRADE,CREDITS,INSTALL}
rm -rf %{buildroot}%{_datadir}/mediawiki/docs

# remove unneeded parts
rm -fr %{buildroot}%{_datadir}/mediawiki/{t,test,tests}
find %{buildroot}%{_datadir}/mediawiki/ -name .htaccess -exec rm -f {} +

# fix permissions
find %{buildroot}%{_datadir}/mediawiki -name \*.pl -exec chmod +x {} +

# remove version control/patch files
find %{buildroot} -name .git\* -exec rm -f {} +

%{__install} -d -m 755 %{buildroot}%{webappconfdir}
install -p -m 0644 %{SOURCE1} \
  %{buildroot}%{webappconfdir}/mediawiki.conf

mkdir %{buildroot}%{_sysconfdir}/mediawiki

# placeholder for a default instance
mkdir -p %{buildroot}/%{_localstatedir}/www/mediawiki

# move editable things out of /usr
mv %{buildroot}%{_datadir}/mediawiki/images %{buildroot}%{_localstatedir}/www/mediawiki/images
ln -s %{_sysconfdir}/mediawiki/LocalSettings.php %{buildroot}%{_datadir}/mediawiki/LocalSettings.php

install -d -m 755 %{buildroot}/%{_localstatedir}/lib/mediawiki

%pretrans
if [ -f %{_datadir}/mediawiki/LocalSettings.php -a ! -L %{_datadir}/mediawiki/LocalSettings.php ]; then
    if [ -e %{_sysconfdir}/mediawiki/LocalSettings.php ]; then
        mv -f %{_sysconfdir}/mediawiki/LocalSettings.php %{_sysconfdir}/mediawiki/LocalSettings.php.rpmsave
    fi
    mv %{_datadir}/mediawiki/LocalSettings.php %{_sysconfdir}/mediawiki/LocalSettings.php
    ln -s %{_sysconfdir}/mediawiki/LocalSettings.php %{_datadir}/mediawiki/LocalSettings.php
fi
if [ -d %{_datadir}/mediawiki/images -a ! -L %{_datadir}/mediawiki/images ]; then
    if [ -e %{_localstatedir}/www/mediawiki/images ]; then
        mv -f %{_localstatedir}/www/mediawiki/images %{_localstatedir}/www/mediawiki/images.rpmsave
    fi
    mv %{_datadir}/mediawiki/images %{_localstatedir}/www/mediawiki/images
    ln -s %{_localstatedir}/www/mediawiki/images %{_datadir}/mediawiki/images
    chown -R apache:apache %{_localstatedir}/www/mediawiki/images
fi

%post
php %{_datadir}/mediawiki/maintenance/update.php --quick > /dev/null
if [ ! -e %{_datadir}/mediawiki/images ]; then
    ln -s %{_localstatedir}/www/mediawiki/images %{_datadir}/mediawiki/images
fi

%files
%doc COPYING FAQ HISTORY README RELEASE-NOTES-%{basever} UPGRADE CREDITS INSTALL docs
%{_datadir}/mediawiki
%attr(-,apache,apache) %dir %{_datadir}/mediawiki/mw-config
%config(noreplace) %{webappconfdir}/mediawiki.conf
%dir %{_sysconfdir}/mediawiki
%dir %{_localstatedir}/www/mediawiki
%attr(-,apache,apache) %dir %{_localstatedir}/www/mediawiki/images
%attr(-,apache,apache) %{_localstatedir}/www/mediawiki/images/README

%files mysql

%files pgsql

%files sqlite
%attr(-,apache,apache) %{_localstatedir}/lib/mediawiki


%changelog
* Tue Oct 20 2015 luigiwalser <luigiwalser> 1.23.11-1.mga5
+ Revision: 893010
- 1.23.11
- 1.23.10

* Wed Apr 01 2015 luigiwalser <luigiwalser> 1.23.9-1.mga5
+ Revision: 819489
- 1.23.9

* Sun Dec 21 2014 luigiwalser <luigiwalser> 1.23.8-1.mga5
+ Revision: 804611
- 1.23.8

* Tue Dec 02 2014 luigiwalser <luigiwalser> 1.23.7-1.mga5
+ Revision: 800292
- 1.23.7

* Wed Oct 29 2014 luigiwalser <luigiwalser> 1.23.6-1.mga5
+ Revision: 794610
- 1.23.6

* Thu Oct 23 2014 luigiwalser <luigiwalser> 1.23.5-5.mga5
+ Revision: 792712
- do not create backup files when patching

* Thu Oct 23 2014 luigiwalser <luigiwalser> 1.23.5-4.mga5
+ Revision: 792565
- patch out wikimedia-specific code that causes autoreq deps problem

* Wed Oct 15 2014 umeabot <umeabot> 1.23.5-3.mga5
+ Revision: 742738
- Second Mageia 5 Mass Rebuild

* Fri Oct 03 2014 diogenese <diogenese> 1.23.5-2.mga5
+ Revision: 736412
- Store sqlite database in mediawiki var directory

* Thu Oct 02 2014 luigiwalser <luigiwalser> 1.23.5-1.mga5
+ Revision: 734704
- 1.23.5

* Wed Oct 01 2014 tv <tv> 1.23.4-2.mga5
+ Revision: 733992
- rebuild for pear deps

* Fri Sep 26 2014 luigiwalser <luigiwalser> 1.23.4-1.mga5
+ Revision: 725435
- 1.23.4

* Tue Sep 16 2014 umeabot <umeabot> 1.23.3-2.mga5
+ Revision: 682335
- Mageia 5 Mass Rebuild

  + tv <tv>
    - use %%global for req/prov exclude
    - autoconvert to new prov/req excludes
    - s/uggests:/Recommends:/

* Thu Aug 28 2014 luigiwalser <luigiwalser> 1.23.3-1.mga5
+ Revision: 669146
- 1.23.3

* Thu Jul 31 2014 luigiwalser <luigiwalser> 1.23.2-1.mga5
+ Revision: 658768
- 1.23.2

* Thu Jun 26 2014 luigiwalser <luigiwalser> 1.23.1-1.mga5
+ Revision: 639930
- 1.23.1

* Thu Jun 05 2014 tmb <tmb> 1.23.0-1.mga5
+ Revision: 633562
- update to 1.23 (LTS)

* Tue Jun 03 2014 luigiwalser <luigiwalser> 1.22.7-1.mga5
+ Revision: 632599
- 1.22.7

* Sat Apr 26 2014 luigiwalser <luigiwalser> 1.22.6-1.mga5
+ Revision: 618271
- 1.22.6

* Fri Mar 28 2014 luigiwalser <luigiwalser> 1.22.5-1.mga5
+ Revision: 609054
- 1.22.5

* Sat Mar 15 2014 luigiwalser <luigiwalser> 1.22.4-1.mga5
+ Revision: 604013
- 1.22.4

* Tue Mar 04 2014 luigiwalser <luigiwalser> 1.22.3-1.mga5
+ Revision: 599475
- 1.22.3
- update source URL

* Wed Feb 26 2014 luigiwalser <luigiwalser> 1.22.2-3.mga5
+ Revision: 597405
- obsolete unmaintained, insecure graphviz extension

* Wed Feb 26 2014 luigiwalser <luigiwalser> 1.22.2-2.mga5
+ Revision: 597404
- remove broken, undocumented instances feature
- run db schema upgrade maintenance script in post scriplet

* Thu Feb 06 2014 luigiwalser <luigiwalser> 1.22.2-1.mga5
+ Revision: 584845
- 1.22.2
- cosmetic fixes in spec file
- require php-pdo_sqlite for mediawiki-sqlite (from diogenese)

* Mon Dec 02 2013 luigiwalser <luigiwalser> 1.20.8-1.mga4
+ Revision: 554660
- 1.20.8

* Sat Oct 19 2013 umeabot <umeabot> 1.20.7-2.mga4
+ Revision: 533771
- Mageia 4 Mass Rebuild

* Wed Sep 04 2013 luigiwalser <luigiwalser> 1.20.7-1.mga4
+ Revision: 475117
- 1.20.7

* Thu Jul 18 2013 luigiwalser <luigiwalser> 1.20.6-3.mga4
+ Revision: 455979
- obsolete bundled renameuser mediawiki extension

* Wed Jul 17 2013 luigiwalser <luigiwalser> 1.20.6-2.mga4
+ Revision: 455129
- allow access to wiki but restrict access to installer
- fix setting conflict with suhosin
- only require webserver-base for apache user
- suggest php-intl to speed up unicode
- move LocalSettings.php to /etc/mediawiki
- move "images" file upload directory to /var/www/mediawiki

* Thu May 23 2013 kharec <kharec> 1.20.6-1.mga4
+ Revision: 425149
- update to 1.20.6

* Sat May 04 2013 kharec <kharec> 1.20.5-1.mga3
+ Revision: 412242
- New security release 1.20.5 (#3448)

* Thu Apr 18 2013 kharec <kharec> 1.20.4-1.mga3
+ Revision: 410429
- Security release 1.20.4

* Sat Apr 13 2013 guillomovitch <guillomovitch> 1.20.3-1.mga3
+ Revision: 409877
- drop references to non existing README.urpmi in package description
- ship a single apache configuration file, providing a simple setup working ouf of the box (#7443)
- ship /var/lib/mediawiki as database container in mediawiki-sqlite
- fix documentation file installation directory
- cleanup spec file

  + kharec <kharec>
    - New version 1.20.3
    - Clean package

* Sat Jan 12 2013 umeabot <umeabot> 1.19.2-3.mga3
+ Revision: 359904
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sat Sep 08 2012 guillomovitch <guillomovitch> 1.19.2-2.mga3
+ Revision: 290498
- make configuration file compatible with apache 2.4
- make default configuration file compliant with setup

  + obgr_seneca <obgr_seneca>
    - fixed README.urpmi

* Sat Sep 08 2012 obgr_seneca <obgr_seneca> 1.19.2-1.mga3
+ Revision: 290105
- new version 1.19.2
- reworked instance creation script

* Tue Jul 10 2012 obgr_seneca <obgr_seneca> 1.19.1-1.mga3
+ Revision: 269190
- New version 1.19.1
- main package now named mediawiki, not mediawiki-minimal
- math package now in an external extension (upstream change)
- added database meta packages for mysql, postgresql and sqlite

* Sat Nov 19 2011 spuhler <spuhler> 1.16.5-3.mga2
+ Revision: 169372
- added pear(extensions\\|pear(PHPUnit/Framework.php) to define _requires_exceptions
  dropped pear(HTML/Template/PHPTAL.php)\\|pear(MogileFS.php) from define _requires_exceptions as it isn't required anymore

* Thu Jun 23 2011 cjw <cjw> 1.16.5-2.mga2
+ Revision: 112830
- fix create script reference in update script

* Sun May 15 2011 boklm <boklm> 1.16.5-1.mga1
+ Revision: 98859
- update to version 1.16.4 (security release)
- remove apache-mod_php dependency as it could be used with other web servers, or without mod_php
- add default config file

  + cjw <cjw>
    - add note about upgrading in README.RPM
    - rebase on mediawiki package in fedora:
      o split code from configuration/userdata
      o allow multiple wiki instances
      o allow installations without tex
    - rename nomath package to mediawiki-minimal
    - rename math package to mediawiki
    - 1.16.5 security release
    - fix patch0 to support wiki installs using a postgresql database
    - rename mw-createinstance to mediawiki-create and
      mw-updateallinstances to mediawiki-updateall
    - fix filelist by listing all files and dirs in the shared code dir

* Mon Mar 21 2011 boklm <boklm> 1.16.2-4.mga1
+ Revision: 75276
- add provide on base version
- install mediawiki in /usr/share/mediawiki and config in /etc/mediawiki
- update summary and description
- remove all plugins
- imported package mediawiki

